<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>NANO102/112 BSP: StdDriver/src/retarget.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../M0Banner_v2.jpg"/></td>
  <td id="projectalign">
   <div id="projectname">NANO102/112 BSP<span id="projectnumber">&#160;V3.04.000</span>
   </div>
   <div id="projectbrief">The Board Support Package for Nano102/112 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',false,false,'search.php','Search');
});
/* @license-end */
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_0d398eaf8b2db165a9197a6619ec9f0e.html">StdDriver</a></li><li class="navelem"><a class="el" href="../../dir_3abedc03644d33bc69016fb8a5546004.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">retarget.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d3/d3d/retarget_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**************************************************************************/</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="preprocessor">#include &lt;stdio.h&gt;</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="preprocessor">#include &quot;<a class="code" href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a>&quot;</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span> </div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#if defined (__ICCARM__)</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">    #pragma diag_suppress=Pm150</span></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#if defined ( __CC_ARM   )</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">    #if (__ARMCC_VERSION &lt; 400000)</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">    #else</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>        <span class="comment">/* Insist on keeping widthprec, to avoid X propagation by benign code in C-lib */</span></div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="preprocessor">        #pragma import _printf_widthprec</span></div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span><span class="preprocessor">    #endif</span></div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span><span class="preprocessor">#ifndef DEBUG_PORT</span></div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">   28</a></span><span class="preprocessor">    #define DEBUG_PORT   UART0</span></div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a6821bafc3c88dfb2e433a095df9940c6">   30</a></span><span class="preprocessor"># define BUF_SIZE     512</span></div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span><span class="comment">/*---------------------------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span><span class="comment">/* Global variables                                                                                        */</span></div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span><span class="comment">/*---------------------------------------------------------------------------------------------------------*/</span></div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span><span class="preprocessor">#if !(defined(__ICCARM__) &amp;&amp; (__VER__ &gt;= 6010000))</span></div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span><span class="preprocessor">#if (__ARMCC_VERSION &lt; 6040000)</span></div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno"><a class="line" href="../../da/d3e/struct_____f_i_l_e.html">   38</a></span><span class="keyword">struct </span><a class="code hl_struct" href="../../da/d3e/struct_____f_i_l_e.html">__FILE</a></div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>{</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno"><a class="line" href="../../da/d3e/struct_____f_i_l_e.html#ac65d6afc3b2c74e74d56195829a1626f">   40</a></span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../da/d3e/struct_____f_i_l_e.html#ac65d6afc3b2c74e74d56195829a1626f">handle</a>; <span class="comment">/* Add whatever you need here */</span></div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>};</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span><span class="preprocessor">#if !defined(__MICROLIB)</span></div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span><span class="preprocessor">    #if (__OPTIMIZE__ == -O0)</span></div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>        __asm(<span class="stringliteral">&quot;.global __ARM_use_no_argv\n\t&quot;</span> <span class="stringliteral">&quot;__ARM_use_no_argv:\n\t&quot;</span>);</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span><span class="preprocessor">    #endif </span><span class="comment">/* (__OPTIMIZE__ == -O0) */</span><span class="preprocessor"></span></div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span><span class="preprocessor">#endif </span><span class="comment">/* !defined(__MICROLIB) */</span><span class="preprocessor"></span></div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span><span class="preprocessor">#endif </span><span class="comment">/* (__ARMCC_VERSION &lt; 6040000) */</span><span class="preprocessor"></span></div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span> </div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span><span class="preprocessor">#elif(__VER__ &gt;= 8000000)</span></div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span><span class="keyword">struct </span><a class="code hl_struct" href="../../da/d3e/struct_____f_i_l_e.html">__FILE</a></div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>{</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>    <span class="keywordtype">int</span> <a class="code hl_variable" href="../../da/d3e/struct_____f_i_l_e.html#ac65d6afc3b2c74e74d56195829a1626f">handle</a>; <span class="comment">/* Add whatever you need here */</span></div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>};</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span><span class="preprocessor">#endif </span><span class="comment">/* !(defined(__ICCARM__) &amp;&amp; (__VER__ &gt;= 6010000)) */</span><span class="preprocessor"></span></div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#ac1f65ebf7d6f28fb49530ee0095306cb">   57</a></span>FILE <a class="code hl_variable" href="../../d3/d3d/retarget_8c.html#ac1f65ebf7d6f28fb49530ee0095306cb">__stdout</a>;</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#abb2a819d3c88269eba04ea62d759bef5">   58</a></span>FILE <a class="code hl_variable" href="../../d3/d3d/retarget_8c.html#abb2a819d3c88269eba04ea62d759bef5">__stdin</a>;</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span> </div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span><span class="preprocessor">#if defined (__ARMCC_VERSION) || defined (__ICCARM__)</span></div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>    <span class="keyword">extern</span> int32_t SH_DoCommand(int32_t n32In_R0, int32_t n32In_R1, int32_t *pn32Out_R0);</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span> </div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span><span class="preprocessor">    #if defined( __ICCARM__ )</span></div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>        <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ac607bf387b29162be6a9b77fc7999539">__WEAK</a></div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span><span class="preprocessor">    #else</span></div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>        <a class="code hl_function" href="../../d3/d0c/group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf94add8ada1485e9cedbf027acebfa00">__attribute__</a>((weak))</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    <span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    uint32_t ProcessHardFault(uint32_t <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a>, uint32_t msp, uint32_t psp);</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span> </div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span><span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a97e9b1fe8d4c010474637a654aad6566">kbhit</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span><span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a5a6e4a05dd526dca0c0432dc738a7a02">IsDebugFifoEmpty</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a1647e9479b4be5731d79c81af76826c5">_ttywrch</a>(<span class="keywordtype">int</span> ch);</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span><span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a32d2b4f69d4059618d9c49a894523cfa">fputc</a>(<span class="keywordtype">int</span> ch, FILE *stream);</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span> </div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span><span class="preprocessor">#if defined ( __GNUC__ ) &amp;&amp; !defined (__ARMCC_VERSION)</span></div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span><span class="preprocessor">    #if !defined (OS_USE_SEMIHOSTING)</span></div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        <span class="keywordtype">int</span> _read(<span class="keywordtype">int</span> fd, <span class="keywordtype">char</span> *ptr, <span class="keywordtype">int</span> len);</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span><span class="preprocessor">    #endif</span></div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span> </div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>    <span class="keywordtype">int</span> _write(<span class="keywordtype">int</span> fd, <span class="keywordtype">char</span> *ptr, <span class="keywordtype">int</span> len);</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span> </div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span><span class="preprocessor">#if defined (__ARMCC_VERSION) || defined (__ICCARM__)</span></div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>    <span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#ab11a990e4f8863a1e7736e3c1d430092">fgetc</a>(FILE *stream);</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>    <span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a4a98383bb54291c2abede7aa28acf597">ferror</a>(FILE *stream);</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span> </div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span><span class="keywordtype">char</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#ad71fc5c80d56f83994f96dc83d0bbabe">GetChar</a>(<span class="keywordtype">void</span>);</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a6810d0fa478aa8204d73d9fc5d026c64">SendChar_ToUART</a>(<span class="keywordtype">int</span> ch);</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a49be7df965b3acf68e2c5c82d6869ab6">SendChar</a>(<span class="keywordtype">int</span> ch);</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#af1f65f8ccc2d14501465115086e9c761">   93</a></span><span class="keyword">static</span> <span class="keyword">volatile</span> int32_t <a class="code hl_variable" href="../../d3/d3d/retarget_8c.html#af1f65f8ccc2d14501465115086e9c761">g_ICE_Conneced</a> = 1;</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">   94</a></span><span class="keyword">enum</span> { <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca20eb91018c3024df2ae3582f6e8e662c">r0</a>, <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca9e5d4ad994db934322c89e4dbef3f7ce">r1</a>, <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca22827a377de213db078757f368a86b05">r2</a>, <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca5d5f095a80fd85c2eb082cf401ea61bd">r3</a>, <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06cab85e19a5be81ee4c3b2e1a7f1081b01a">r12</a>, <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a>, <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca0d008574886a382d46ba2616c506af41">pc</a>, <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06cafd586543cfec6b0f210fe63e60296dcd">psr</a>};</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span> </div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span> </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a099c43ad08420cc1950b5958939dbb0b">  103</a></span><span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a099c43ad08420cc1950b5958939dbb0b">DumpStack</a>(uint32_t stack[])</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>{</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>    <span class="comment">/*</span></div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span><span class="comment">        printf(&quot;r0 =0x%x\n&quot;, stack[r0]);</span></div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span><span class="comment">        printf(&quot;r1 =0x%x\n&quot;, stack[r1]);</span></div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span><span class="comment">        printf(&quot;r2 =0x%x\n&quot;, stack[r2]);</span></div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span><span class="comment">        printf(&quot;r3 =0x%x\n&quot;, stack[r3]);</span></div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span><span class="comment">        printf(&quot;r12=0x%x\n&quot;, stack[r12]);</span></div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span><span class="comment">        printf(&quot;lr =0x%x\n&quot;, stack[lr]);</span></div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span><span class="comment">        printf(&quot;pc =0x%x\n&quot;, stack[pc]);</span></div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span><span class="comment">        printf(&quot;psr=0x%x\n&quot;, stack[psr]);</span></div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span><span class="comment">    */</span></div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>}</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span> </div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span> </div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span><span class="preprocessor">#if defined(DEBUG_ENABLE_SEMIHOST)</span></div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span> </div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span><span class="comment">/* The static buffer is used to speed up the semihost */</span></div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span><span class="keyword">static</span> <span class="keywordtype">char</span> g_buf[16];</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span><span class="keyword">static</span> <span class="keywordtype">char</span> g_buf_len = 0;</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span> </div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>int32_t <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a0a9d8f093940fa3017cf1d9337ce5f25">SH_Return</a>(int32_t n32In_R0, int32_t n32In_R1, int32_t *pn32Out_R0)</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>{</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>    <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d3/d3d/retarget_8c.html#af1f65f8ccc2d14501465115086e9c761">g_ICE_Conneced</a>)</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    {</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>        <span class="keywordflow">if</span> (pn32Out_R0)</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>            *pn32Out_R0 = n32In_R0;</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span> </div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>        <span class="keywordflow">return</span> 1;</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>    }</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span> </div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>    <span class="keywordflow">return</span> 0;</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>}</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span> </div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span><span class="preprocessor">#else </span><span class="comment">// defined(DEBUG_ENABLE_SEMIHOST)</span></div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span> </div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span><span class="preprocessor">#if defined ( __GNUC__ ) &amp;&amp; !defined (__ARMCC_VERSION)</span></div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span> </div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span><a class="code hl_function" href="../../d3/d0c/group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf94add8ada1485e9cedbf027acebfa00">__attribute__</a>((weak)) <span class="keywordtype">void</span> HardFault_Handler(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>{</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>    <span class="keyword">asm</span>(<span class="stringliteral">&quot;MOV     R0, LR  \n&quot;</span></div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>        <span class="stringliteral">&quot;MRS     R1, MSP \n&quot;</span></div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        <span class="stringliteral">&quot;MRS     R2, PSP \n&quot;</span></div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span>        <span class="stringliteral">&quot;LDR     R3, =ProcessHardFault \n&quot;</span></div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>        <span class="stringliteral">&quot;BLX     R3 \n&quot;</span></div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>        <span class="stringliteral">&quot;BX      R0 \n&quot;</span></div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>       );</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>}</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span> </div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>int32_t <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a0a9d8f093940fa3017cf1d9337ce5f25">SH_Return</a>(int32_t n32In_R0, int32_t n32In_R1, int32_t *pn32Out_R0);</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a0a9d8f093940fa3017cf1d9337ce5f25">  175</a></span>int32_t <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a0a9d8f093940fa3017cf1d9337ce5f25">SH_Return</a>(int32_t n32In_R0, int32_t n32In_R1, int32_t *pn32Out_R0)</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>{</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>    <span class="keywordflow">return</span> 0;</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>}</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span> </div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span><span class="preprocessor">#endif </span><span class="comment">/* defined(DEBUG_ENABLE_SEMIHOST) */</span><span class="preprocessor"></span></div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span> </div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span> </div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span><span class="preprocessor">#if defined( __ICCARM__ )</span></div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>    <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ac607bf387b29162be6a9b77fc7999539">__WEAK</a></div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno"><a class="line" href="../../d3/d0c/group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf94add8ada1485e9cedbf027acebfa00">  187</a></span>    <a class="code hl_function" href="../../d3/d0c/group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf94add8ada1485e9cedbf027acebfa00">__attribute__</a>((weak))</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>uint32_t ProcessHardFault(uint32_t <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a>, uint32_t msp, uint32_t psp)</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>{</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>    uint32_t *sp;</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>    uint32_t inst;</div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span> </div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>    <span class="comment">/* It is casued by hardfault. Just process the hard fault */</span></div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>    <span class="comment">/* TODO: Implement your hardfault handle code here */</span></div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span> </div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>    <span class="comment">/* Check the used stack */</span></div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span><span class="preprocessor">#if defined (__ARM_FEATURE_CMSE) &amp;&amp;  (__ARM_FEATURE_CMSE == 3)</span></div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span> </div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>    <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a> &amp; 0x40UL)</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>    {</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span> </div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span>        <span class="comment">/* Secure stack used */</span></div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>        <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a> &amp; 4UL)</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>        {</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>            sp = (uint32_t *)psp;</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>        }</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>        {</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>            sp = (uint32_t *)msp;</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>        }</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span> </div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span><span class="preprocessor">#if defined (__ARM_FEATURE_CMSE) &amp;&amp;  (__ARM_FEATURE_CMSE == 3)</span></div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>    }</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>    {</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>        <span class="comment">/* Non-secure stack used */</span></div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span>        <span class="keywordflow">if</span> (<a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a> &amp; 4)</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno">  220</span>            sp = (uint32_t *)__TZ_get_PSP_NS();</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>            sp = (uint32_t *)__TZ_get_MSP_NS();</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>    }</div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span> </div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span> </div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>    <span class="comment">/* Get the instruction caused the hardfault */</span></div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>    inst = <a class="code hl_define" href="../../d6/d70/group___n_a_n_o1_x2___i_o___r_o_u_t_i_n_e.html#ga5421a39a0460ea2269ae45d3e9909991">M16</a>(sp[6]);</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span> </div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>    <span class="keywordflow">if</span> (inst == 0xBEAB)</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>    {</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>        <span class="comment">/*</span></div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span><span class="comment">            If the instruction is 0xBEAB, it means it is caused by BKPT without ICE connected.</span></div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span><span class="comment">            We still return for output/input message to UART.</span></div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span><span class="comment">        */</span></div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span>        <a class="code hl_variable" href="../../d3/d3d/retarget_8c.html#af1f65f8ccc2d14501465115086e9c761">g_ICE_Conneced</a> = 0; <span class="comment">// Set a flag for ICE offline</span></div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>        sp[6] += 2;         <span class="comment">// Return to next instruction</span></div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>        <span class="keywordflow">return</span> <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a>;          <span class="comment">// Keep lr in R0</span></div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>    }</div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span> </div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>    printf(<span class="stringliteral">&quot;  HardFault!\n\n&quot;</span>);</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>    <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a099c43ad08420cc1950b5958939dbb0b">DumpStack</a>(sp);</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span> </div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno">  244</span>    <span class="comment">/* Or *sp to remove compiler warning */</span></div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>    <span class="keywordflow">while</span> (1U | *sp) {}</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span> </div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span>    <span class="keywordflow">return</span> <a class="code hl_enumvalue" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a>;</div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>}</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span> </div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span> </div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span><span class="preprocessor">#ifndef NONBLOCK_PRINTF</span></div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a6810d0fa478aa8204d73d9fc5d026c64">  261</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a6810d0fa478aa8204d73d9fc5d026c64">SendChar_ToUART</a>(<span class="keywordtype">int</span> ch)</div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno">  262</span>{</div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>    <span class="keywordflow">while</span> (<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a3669d9c05470178c27d910994a1bb512">UART_FSR_TX_FULL_F_Msk</a>) {}</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span> </div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>    <span class="keywordflow">if</span> ((<span class="keywordtype">char</span>)ch == <span class="charliteral">&#39;\n&#39;</span>)</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>    {</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>        <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;THR = <span class="charliteral">&#39;\r&#39;</span>;</div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span> </div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>        <span class="keywordflow">while</span> (<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a3669d9c05470178c27d910994a1bb512">UART_FSR_TX_FULL_F_Msk</a>) {}</div>
<div class="line"><a id="l00270" name="l00270"></a><span class="lineno">  270</span> </div>
<div class="line"><a id="l00271" name="l00271"></a><span class="lineno">  271</span>    }</div>
<div class="line"><a id="l00272" name="l00272"></a><span class="lineno">  272</span> </div>
<div class="line"><a id="l00273" name="l00273"></a><span class="lineno">  273</span>    <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;THR = (uint32_t)ch;</div>
<div class="line"><a id="l00274" name="l00274"></a><span class="lineno">  274</span>}</div>
<div class="line"><a id="l00275" name="l00275"></a><span class="lineno">  275</span> </div>
<div class="line"><a id="l00276" name="l00276"></a><span class="lineno">  276</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00277" name="l00277"></a><span class="lineno">  277</span> </div>
<div class="line"><a id="l00278" name="l00278"></a><span class="lineno">  278</span><span class="comment">/* Non-block implement of send char */</span></div>
<div class="line"><a id="l00279" name="l00279"></a><span class="lineno">  279</span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a6810d0fa478aa8204d73d9fc5d026c64">SendChar_ToUART</a>(<span class="keywordtype">int</span> ch)</div>
<div class="line"><a id="l00280" name="l00280"></a><span class="lineno">  280</span>{</div>
<div class="line"><a id="l00281" name="l00281"></a><span class="lineno">  281</span>    <span class="keyword">static</span> uint8_t u8Buf[<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#a6821bafc3c88dfb2e433a095df9940c6">BUF_SIZE</a>] = {0};</div>
<div class="line"><a id="l00282" name="l00282"></a><span class="lineno">  282</span>    <span class="keyword">static</span> int32_t i32Head = 0;</div>
<div class="line"><a id="l00283" name="l00283"></a><span class="lineno">  283</span>    <span class="keyword">static</span> int32_t i32Tail = 0;</div>
<div class="line"><a id="l00284" name="l00284"></a><span class="lineno">  284</span>    int32_t i32Tmp;</div>
<div class="line"><a id="l00285" name="l00285"></a><span class="lineno">  285</span> </div>
<div class="line"><a id="l00286" name="l00286"></a><span class="lineno">  286</span>    <span class="comment">/* Only flush the data in buffer to UART when ch == 0 */</span></div>
<div class="line"><a id="l00287" name="l00287"></a><span class="lineno">  287</span>    <span class="keywordflow">if</span> (ch)</div>
<div class="line"><a id="l00288" name="l00288"></a><span class="lineno">  288</span>    {</div>
<div class="line"><a id="l00289" name="l00289"></a><span class="lineno">  289</span>        <span class="comment">// Push char</span></div>
<div class="line"><a id="l00290" name="l00290"></a><span class="lineno">  290</span> </div>
<div class="line"><a id="l00291" name="l00291"></a><span class="lineno">  291</span>        <span class="keywordflow">if</span> (ch == <span class="charliteral">&#39;\n&#39;</span>)</div>
<div class="line"><a id="l00292" name="l00292"></a><span class="lineno">  292</span>        {</div>
<div class="line"><a id="l00293" name="l00293"></a><span class="lineno">  293</span>            i32Tmp = i32Head + 1;</div>
<div class="line"><a id="l00294" name="l00294"></a><span class="lineno">  294</span> </div>
<div class="line"><a id="l00295" name="l00295"></a><span class="lineno">  295</span>            <span class="keywordflow">if</span> (i32Tmp &gt; <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#a6821bafc3c88dfb2e433a095df9940c6">BUF_SIZE</a>) i32Tmp = 0;</div>
<div class="line"><a id="l00296" name="l00296"></a><span class="lineno">  296</span> </div>
<div class="line"><a id="l00297" name="l00297"></a><span class="lineno">  297</span>            <span class="keywordflow">if</span> (i32Tmp != i32Tail)</div>
<div class="line"><a id="l00298" name="l00298"></a><span class="lineno">  298</span>            {</div>
<div class="line"><a id="l00299" name="l00299"></a><span class="lineno">  299</span>                u8Buf[i32Head] = <span class="charliteral">&#39;\r&#39;</span>;</div>
<div class="line"><a id="l00300" name="l00300"></a><span class="lineno">  300</span>                i32Head = i32Tmp;</div>
<div class="line"><a id="l00301" name="l00301"></a><span class="lineno">  301</span>            }</div>
<div class="line"><a id="l00302" name="l00302"></a><span class="lineno">  302</span>        }</div>
<div class="line"><a id="l00303" name="l00303"></a><span class="lineno">  303</span> </div>
<div class="line"><a id="l00304" name="l00304"></a><span class="lineno">  304</span>        i32Tmp = i32Head + 1;</div>
<div class="line"><a id="l00305" name="l00305"></a><span class="lineno">  305</span> </div>
<div class="line"><a id="l00306" name="l00306"></a><span class="lineno">  306</span>        <span class="keywordflow">if</span> (i32Tmp &gt; <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#a6821bafc3c88dfb2e433a095df9940c6">BUF_SIZE</a>) i32Tmp = 0;</div>
<div class="line"><a id="l00307" name="l00307"></a><span class="lineno">  307</span> </div>
<div class="line"><a id="l00308" name="l00308"></a><span class="lineno">  308</span>        <span class="keywordflow">if</span> (i32Tmp != i32Tail)</div>
<div class="line"><a id="l00309" name="l00309"></a><span class="lineno">  309</span>        {</div>
<div class="line"><a id="l00310" name="l00310"></a><span class="lineno">  310</span>            u8Buf[i32Head] = ch;</div>
<div class="line"><a id="l00311" name="l00311"></a><span class="lineno">  311</span>            i32Head = i32Tmp;</div>
<div class="line"><a id="l00312" name="l00312"></a><span class="lineno">  312</span>        }</div>
<div class="line"><a id="l00313" name="l00313"></a><span class="lineno">  313</span>    }</div>
<div class="line"><a id="l00314" name="l00314"></a><span class="lineno">  314</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00315" name="l00315"></a><span class="lineno">  315</span>    {</div>
<div class="line"><a id="l00316" name="l00316"></a><span class="lineno">  316</span>        <span class="keywordflow">if</span> (i32Tail == i32Head)</div>
<div class="line"><a id="l00317" name="l00317"></a><span class="lineno">  317</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00318" name="l00318"></a><span class="lineno">  318</span>    }</div>
<div class="line"><a id="l00319" name="l00319"></a><span class="lineno">  319</span> </div>
<div class="line"><a id="l00320" name="l00320"></a><span class="lineno">  320</span>    <span class="comment">// Pop char</span></div>
<div class="line"><a id="l00321" name="l00321"></a><span class="lineno">  321</span>    <span class="keywordflow">do</span></div>
<div class="line"><a id="l00322" name="l00322"></a><span class="lineno">  322</span>    {</div>
<div class="line"><a id="l00323" name="l00323"></a><span class="lineno">  323</span>        i32Tmp = i32Tail + 1;</div>
<div class="line"><a id="l00324" name="l00324"></a><span class="lineno">  324</span> </div>
<div class="line"><a id="l00325" name="l00325"></a><span class="lineno">  325</span>        <span class="keywordflow">if</span> (i32Tmp &gt; <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#a6821bafc3c88dfb2e433a095df9940c6">BUF_SIZE</a>) i32Tmp = 0;</div>
<div class="line"><a id="l00326" name="l00326"></a><span class="lineno">  326</span> </div>
<div class="line"><a id="l00327" name="l00327"></a><span class="lineno">  327</span>        <span class="keywordflow">if</span> ((<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a3669d9c05470178c27d910994a1bb512">UART_FSR_TX_FULL_F_Msk</a>) == 0)</div>
<div class="line"><a id="l00328" name="l00328"></a><span class="lineno">  328</span>        {</div>
<div class="line"><a id="l00329" name="l00329"></a><span class="lineno">  329</span>            <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;THR = u8Buf[i32Tail];</div>
<div class="line"><a id="l00330" name="l00330"></a><span class="lineno">  330</span>            i32Tail = i32Tmp;</div>
<div class="line"><a id="l00331" name="l00331"></a><span class="lineno">  331</span>        }</div>
<div class="line"><a id="l00332" name="l00332"></a><span class="lineno">  332</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00333" name="l00333"></a><span class="lineno">  333</span>            <span class="keywordflow">break</span>; <span class="comment">// FIFO full</span></div>
<div class="line"><a id="l00334" name="l00334"></a><span class="lineno">  334</span>    } <span class="keywordflow">while</span> (i32Tail != i32Head);</div>
<div class="line"><a id="l00335" name="l00335"></a><span class="lineno">  335</span>}</div>
<div class="line"><a id="l00336" name="l00336"></a><span class="lineno">  336</span><span class="preprocessor">#endif </span><span class="comment">/* else for NONBLOCK_PRINTF */</span><span class="preprocessor"></span></div>
<div class="line"><a id="l00337" name="l00337"></a><span class="lineno">  337</span> </div>
<div class="line"><a id="l00338" name="l00338"></a><span class="lineno">  338</span> </div>
<div class="line"><a id="l00349" name="l00349"></a><span class="lineno">  349</span><span class="preprocessor">#if !defined( __ICCARM__ )</span></div>
<div class="line"><a id="l00350" name="l00350"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#ac607bf387b29162be6a9b77fc7999539">  350</a></span><span class="preprocessor">    #define __WEAK    __attribute__((weak))</span></div>
<div class="line"><a id="l00351" name="l00351"></a><span class="lineno">  351</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00352" name="l00352"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a49be7df965b3acf68e2c5c82d6869ab6">  352</a></span><a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ac607bf387b29162be6a9b77fc7999539">__WEAK</a> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a49be7df965b3acf68e2c5c82d6869ab6">SendChar</a>(<span class="keywordtype">int</span> ch)</div>
<div class="line"><a id="l00353" name="l00353"></a><span class="lineno">  353</span>{</div>
<div class="line"><a id="l00354" name="l00354"></a><span class="lineno">  354</span><span class="preprocessor">#if defined(DEBUG_ENABLE_SEMIHOST)</span></div>
<div class="line"><a id="l00355" name="l00355"></a><span class="lineno">  355</span>    g_buf[g_buf_len++] = ch;</div>
<div class="line"><a id="l00356" name="l00356"></a><span class="lineno">  356</span>    g_buf[g_buf_len] = <span class="charliteral">&#39;\0&#39;</span>;</div>
<div class="line"><a id="l00357" name="l00357"></a><span class="lineno">  357</span> </div>
<div class="line"><a id="l00358" name="l00358"></a><span class="lineno">  358</span>    <span class="keywordflow">if</span> (g_buf_len + 1 &gt;= <span class="keyword">sizeof</span>(g_buf) || ch == <span class="charliteral">&#39;\n&#39;</span> || ch == <span class="charliteral">&#39;\0&#39;</span>)</div>
<div class="line"><a id="l00359" name="l00359"></a><span class="lineno">  359</span>    {</div>
<div class="line"><a id="l00360" name="l00360"></a><span class="lineno">  360</span>        <span class="comment">/* Send the char */</span></div>
<div class="line"><a id="l00361" name="l00361"></a><span class="lineno">  361</span>        <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d3/d3d/retarget_8c.html#af1f65f8ccc2d14501465115086e9c761">g_ICE_Conneced</a>)</div>
<div class="line"><a id="l00362" name="l00362"></a><span class="lineno">  362</span>        {</div>
<div class="line"><a id="l00363" name="l00363"></a><span class="lineno">  363</span> </div>
<div class="line"><a id="l00364" name="l00364"></a><span class="lineno">  364</span>            <span class="keywordflow">if</span> (SH_DoCommand(0x04, (<span class="keywordtype">int</span>)g_buf, <a class="code hl_define" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga070d2ce7b6bb7e5c05602aa8c308d0c4">NULL</a>) != 0)</div>
<div class="line"><a id="l00365" name="l00365"></a><span class="lineno">  365</span>            {</div>
<div class="line"><a id="l00366" name="l00366"></a><span class="lineno">  366</span>                g_buf_len = 0;</div>
<div class="line"><a id="l00367" name="l00367"></a><span class="lineno">  367</span> </div>
<div class="line"><a id="l00368" name="l00368"></a><span class="lineno">  368</span>                <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00369" name="l00369"></a><span class="lineno">  369</span>            }</div>
<div class="line"><a id="l00370" name="l00370"></a><span class="lineno">  370</span>        }</div>
<div class="line"><a id="l00371" name="l00371"></a><span class="lineno">  371</span>        <span class="keywordflow">else</span></div>
<div class="line"><a id="l00372" name="l00372"></a><span class="lineno">  372</span>        {</div>
<div class="line"><a id="l00373" name="l00373"></a><span class="lineno">  373</span><span class="preprocessor">#if (DEBUG_ENABLE_SEMIHOST == 1) </span><span class="comment">// Re-direct to UART Debug Port only when DEBUG_ENABLE_SEMIHOST=1</span></div>
<div class="line"><a id="l00374" name="l00374"></a><span class="lineno">  374</span>            <span class="keywordtype">int</span> i;</div>
<div class="line"><a id="l00375" name="l00375"></a><span class="lineno">  375</span> </div>
<div class="line"><a id="l00376" name="l00376"></a><span class="lineno">  376</span>            <span class="keywordflow">for</span> (i = 0; i &lt; g_buf_len; i++)</div>
<div class="line"><a id="l00377" name="l00377"></a><span class="lineno">  377</span>                <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a6810d0fa478aa8204d73d9fc5d026c64">SendChar_ToUART</a>(g_buf[i]);</div>
<div class="line"><a id="l00378" name="l00378"></a><span class="lineno">  378</span> </div>
<div class="line"><a id="l00379" name="l00379"></a><span class="lineno">  379</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00380" name="l00380"></a><span class="lineno">  380</span>            g_buf_len = 0;</div>
<div class="line"><a id="l00381" name="l00381"></a><span class="lineno">  381</span>        }</div>
<div class="line"><a id="l00382" name="l00382"></a><span class="lineno">  382</span>    }</div>
<div class="line"><a id="l00383" name="l00383"></a><span class="lineno">  383</span> </div>
<div class="line"><a id="l00384" name="l00384"></a><span class="lineno">  384</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00385" name="l00385"></a><span class="lineno">  385</span>    <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a6810d0fa478aa8204d73d9fc5d026c64">SendChar_ToUART</a>(ch);</div>
<div class="line"><a id="l00386" name="l00386"></a><span class="lineno">  386</span><span class="preprocessor">#endif </span><span class="comment">/* DEBUG_ENABLE_SEMIHOST */</span><span class="preprocessor"></span></div>
<div class="line"><a id="l00387" name="l00387"></a><span class="lineno">  387</span>}</div>
<div class="line"><a id="l00388" name="l00388"></a><span class="lineno">  388</span> </div>
<div class="line"><a id="l00389" name="l00389"></a><span class="lineno">  389</span> </div>
<div class="line"><a id="l00399" name="l00399"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#ad71fc5c80d56f83994f96dc83d0bbabe">  399</a></span><span class="keywordtype">char</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#ad71fc5c80d56f83994f96dc83d0bbabe">GetChar</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00400" name="l00400"></a><span class="lineno">  400</span>{</div>
<div class="line"><a id="l00401" name="l00401"></a><span class="lineno">  401</span><span class="preprocessor">#ifdef DEBUG_ENABLE_SEMIHOST</span></div>
<div class="line"><a id="l00402" name="l00402"></a><span class="lineno">  402</span> </div>
<div class="line"><a id="l00403" name="l00403"></a><span class="lineno">  403</span>    <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d3/d3d/retarget_8c.html#af1f65f8ccc2d14501465115086e9c761">g_ICE_Conneced</a>)</div>
<div class="line"><a id="l00404" name="l00404"></a><span class="lineno">  404</span>    {</div>
<div class="line"><a id="l00405" name="l00405"></a><span class="lineno">  405</span><span class="preprocessor">#if defined (__ICCARM__)</span></div>
<div class="line"><a id="l00406" name="l00406"></a><span class="lineno">  406</span>        <span class="keywordtype">int</span> nRet;</div>
<div class="line"><a id="l00407" name="l00407"></a><span class="lineno">  407</span> </div>
<div class="line"><a id="l00408" name="l00408"></a><span class="lineno">  408</span>        <span class="keywordflow">while</span> (SH_DoCommand(0x7, 0, &amp;nRet) != 0)</div>
<div class="line"><a id="l00409" name="l00409"></a><span class="lineno">  409</span>        {</div>
<div class="line"><a id="l00410" name="l00410"></a><span class="lineno">  410</span>            <span class="keywordflow">if</span> (nRet != 0)</div>
<div class="line"><a id="l00411" name="l00411"></a><span class="lineno">  411</span>                <span class="keywordflow">return</span> (<span class="keywordtype">char</span>)nRet;</div>
<div class="line"><a id="l00412" name="l00412"></a><span class="lineno">  412</span>        }</div>
<div class="line"><a id="l00413" name="l00413"></a><span class="lineno">  413</span> </div>
<div class="line"><a id="l00414" name="l00414"></a><span class="lineno">  414</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00415" name="l00415"></a><span class="lineno">  415</span>        <span class="keywordtype">int</span> nRet;</div>
<div class="line"><a id="l00416" name="l00416"></a><span class="lineno">  416</span> </div>
<div class="line"><a id="l00417" name="l00417"></a><span class="lineno">  417</span>        <span class="keywordflow">while</span> (SH_DoCommand(0x101, 0, &amp;nRet) != 0)</div>
<div class="line"><a id="l00418" name="l00418"></a><span class="lineno">  418</span>        {</div>
<div class="line"><a id="l00419" name="l00419"></a><span class="lineno">  419</span>            <span class="keywordflow">if</span> (nRet != 0)</div>
<div class="line"><a id="l00420" name="l00420"></a><span class="lineno">  420</span>            {</div>
<div class="line"><a id="l00421" name="l00421"></a><span class="lineno">  421</span>                SH_DoCommand(0x07, 0, &amp;nRet);</div>
<div class="line"><a id="l00422" name="l00422"></a><span class="lineno">  422</span>                <span class="keywordflow">return</span> (<span class="keywordtype">char</span>)nRet;</div>
<div class="line"><a id="l00423" name="l00423"></a><span class="lineno">  423</span>            }</div>
<div class="line"><a id="l00424" name="l00424"></a><span class="lineno">  424</span>        }</div>
<div class="line"><a id="l00425" name="l00425"></a><span class="lineno">  425</span> </div>
<div class="line"><a id="l00426" name="l00426"></a><span class="lineno">  426</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00427" name="l00427"></a><span class="lineno">  427</span> </div>
<div class="line"><a id="l00428" name="l00428"></a><span class="lineno">  428</span>    }</div>
<div class="line"><a id="l00429" name="l00429"></a><span class="lineno">  429</span>    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00430" name="l00430"></a><span class="lineno">  430</span>    {</div>
<div class="line"><a id="l00431" name="l00431"></a><span class="lineno">  431</span> </div>
<div class="line"><a id="l00432" name="l00432"></a><span class="lineno">  432</span><span class="preprocessor">#if (DEBUG_ENABLE_SEMIHOST == 1) </span><span class="comment">// Re-direct to UART Debug Port only when DEBUG_ENABLE_SEMIHOST=1</span></div>
<div class="line"><a id="l00433" name="l00433"></a><span class="lineno">  433</span> </div>
<div class="line"><a id="l00434" name="l00434"></a><span class="lineno">  434</span>        <span class="comment">/* Use debug port when ICE is not connected at semihost mode */</span></div>
<div class="line"><a id="l00435" name="l00435"></a><span class="lineno">  435</span>        <span class="keywordflow">while</span> (!<a class="code hl_variable" href="../../d3/d3d/retarget_8c.html#af1f65f8ccc2d14501465115086e9c761">g_ICE_Conneced</a>)</div>
<div class="line"><a id="l00436" name="l00436"></a><span class="lineno">  436</span>        {</div>
<div class="line"><a id="l00437" name="l00437"></a><span class="lineno">  437</span>            <span class="keywordflow">if</span> ((<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#aa8c7bcb82bb87f1e1e382bcfeb465677">UART_FSR_RX_EMPTY_F_Msk</a>) == 0U)</div>
<div class="line"><a id="l00438" name="l00438"></a><span class="lineno">  438</span>            {</div>
<div class="line"><a id="l00439" name="l00439"></a><span class="lineno">  439</span>                <span class="keywordflow">return</span> ((<span class="keywordtype">char</span>)<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;RBR);</div>
<div class="line"><a id="l00440" name="l00440"></a><span class="lineno">  440</span>            }</div>
<div class="line"><a id="l00441" name="l00441"></a><span class="lineno">  441</span>        }</div>
<div class="line"><a id="l00442" name="l00442"></a><span class="lineno">  442</span> </div>
<div class="line"><a id="l00443" name="l00443"></a><span class="lineno">  443</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00444" name="l00444"></a><span class="lineno">  444</span>    }</div>
<div class="line"><a id="l00445" name="l00445"></a><span class="lineno">  445</span> </div>
<div class="line"><a id="l00446" name="l00446"></a><span class="lineno">  446</span>    <span class="keywordflow">return</span> (0);</div>
<div class="line"><a id="l00447" name="l00447"></a><span class="lineno">  447</span> </div>
<div class="line"><a id="l00448" name="l00448"></a><span class="lineno">  448</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00449" name="l00449"></a><span class="lineno">  449</span> </div>
<div class="line"><a id="l00450" name="l00450"></a><span class="lineno">  450</span>    <span class="keywordflow">while</span> (1)</div>
<div class="line"><a id="l00451" name="l00451"></a><span class="lineno">  451</span>    {</div>
<div class="line"><a id="l00452" name="l00452"></a><span class="lineno">  452</span>        <span class="keywordflow">if</span> ((<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#aa8c7bcb82bb87f1e1e382bcfeb465677">UART_FSR_RX_EMPTY_F_Msk</a>) == 0U)</div>
<div class="line"><a id="l00453" name="l00453"></a><span class="lineno">  453</span>        {</div>
<div class="line"><a id="l00454" name="l00454"></a><span class="lineno">  454</span>            <span class="keywordflow">return</span> ((<span class="keywordtype">char</span>)<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;RBR);</div>
<div class="line"><a id="l00455" name="l00455"></a><span class="lineno">  455</span>        }</div>
<div class="line"><a id="l00456" name="l00456"></a><span class="lineno">  456</span>    }</div>
<div class="line"><a id="l00457" name="l00457"></a><span class="lineno">  457</span> </div>
<div class="line"><a id="l00458" name="l00458"></a><span class="lineno">  458</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00459" name="l00459"></a><span class="lineno">  459</span>}</div>
<div class="line"><a id="l00460" name="l00460"></a><span class="lineno">  460</span> </div>
<div class="line"><a id="l00461" name="l00461"></a><span class="lineno">  461</span> </div>
<div class="line"><a id="l00472" name="l00472"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a97e9b1fe8d4c010474637a654aad6566">  472</a></span><span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a97e9b1fe8d4c010474637a654aad6566">kbhit</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00473" name="l00473"></a><span class="lineno">  473</span>{</div>
<div class="line"><a id="l00474" name="l00474"></a><span class="lineno">  474</span>    <span class="keywordflow">return</span> !((<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#aa8c7bcb82bb87f1e1e382bcfeb465677">UART_FSR_RX_EMPTY_F_Msk</a>) == 0U);</div>
<div class="line"><a id="l00475" name="l00475"></a><span class="lineno">  475</span>}</div>
<div class="line"><a id="l00476" name="l00476"></a><span class="lineno">  476</span> </div>
<div class="line"><a id="l00477" name="l00477"></a><span class="lineno">  477</span> </div>
<div class="line"><a id="l00488" name="l00488"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a5a6e4a05dd526dca0c0432dc738a7a02">  488</a></span><span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a5a6e4a05dd526dca0c0432dc738a7a02">IsDebugFifoEmpty</a>(<span class="keywordtype">void</span>)</div>
<div class="line"><a id="l00489" name="l00489"></a><span class="lineno">  489</span>{</div>
<div class="line"><a id="l00490" name="l00490"></a><span class="lineno">  490</span>    <span class="keywordflow">return</span> ((<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#afefb95cc21b2b73616b108c184730257">UART_FSR_TE_F_Msk</a>) != 0U);</div>
<div class="line"><a id="l00491" name="l00491"></a><span class="lineno">  491</span>}</div>
<div class="line"><a id="l00492" name="l00492"></a><span class="lineno">  492</span> </div>
<div class="line"><a id="l00493" name="l00493"></a><span class="lineno">  493</span> </div>
<div class="line"><a id="l00503" name="l00503"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a1647e9479b4be5731d79c81af76826c5">  503</a></span><span class="keywordtype">void</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a1647e9479b4be5731d79c81af76826c5">_ttywrch</a>(<span class="keywordtype">int</span> ch)</div>
<div class="line"><a id="l00504" name="l00504"></a><span class="lineno">  504</span>{</div>
<div class="line"><a id="l00505" name="l00505"></a><span class="lineno">  505</span>    <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a49be7df965b3acf68e2c5c82d6869ab6">SendChar</a>(ch);</div>
<div class="line"><a id="l00506" name="l00506"></a><span class="lineno">  506</span>    <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00507" name="l00507"></a><span class="lineno">  507</span>}</div>
<div class="line"><a id="l00508" name="l00508"></a><span class="lineno">  508</span> </div>
<div class="line"><a id="l00509" name="l00509"></a><span class="lineno">  509</span> </div>
<div class="line"><a id="l00527" name="l00527"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a32d2b4f69d4059618d9c49a894523cfa">  527</a></span><span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a32d2b4f69d4059618d9c49a894523cfa">fputc</a>(<span class="keywordtype">int</span> ch, FILE *stream)</div>
<div class="line"><a id="l00528" name="l00528"></a><span class="lineno">  528</span>{</div>
<div class="line"><a id="l00529" name="l00529"></a><span class="lineno">  529</span>    <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a49be7df965b3acf68e2c5c82d6869ab6">SendChar</a>(ch);</div>
<div class="line"><a id="l00530" name="l00530"></a><span class="lineno">  530</span>    <span class="keywordflow">return</span> ch;</div>
<div class="line"><a id="l00531" name="l00531"></a><span class="lineno">  531</span>}</div>
<div class="line"><a id="l00532" name="l00532"></a><span class="lineno">  532</span> </div>
<div class="line"><a id="l00533" name="l00533"></a><span class="lineno">  533</span> </div>
<div class="line"><a id="l00534" name="l00534"></a><span class="lineno">  534</span><span class="preprocessor">#if defined ( __GNUC__ ) &amp;&amp; !defined (__ARMCC_VERSION)</span></div>
<div class="line"><a id="l00535" name="l00535"></a><span class="lineno">  535</span> </div>
<div class="line"><a id="l00536" name="l00536"></a><span class="lineno">  536</span><span class="preprocessor">#if defined (OS_USE_SEMIHOSTING)</span></div>
<div class="line"><a id="l00537" name="l00537"></a><span class="lineno">  537</span> </div>
<div class="line"><a id="l00538" name="l00538"></a><span class="lineno">  538</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00539" name="l00539"></a><span class="lineno">  539</span> </div>
<div class="line"><a id="l00540" name="l00540"></a><span class="lineno">  540</span><span class="keywordtype">int</span> _write(<span class="keywordtype">int</span> fd, <span class="keywordtype">char</span> *ptr, <span class="keywordtype">int</span> len)</div>
<div class="line"><a id="l00541" name="l00541"></a><span class="lineno">  541</span>{</div>
<div class="line"><a id="l00542" name="l00542"></a><span class="lineno">  542</span>    <span class="keywordtype">int</span> i = len;</div>
<div class="line"><a id="l00543" name="l00543"></a><span class="lineno">  543</span> </div>
<div class="line"><a id="l00544" name="l00544"></a><span class="lineno">  544</span>    <span class="keywordflow">while</span> (i--)</div>
<div class="line"><a id="l00545" name="l00545"></a><span class="lineno">  545</span>    {</div>
<div class="line"><a id="l00546" name="l00546"></a><span class="lineno">  546</span>        <span class="keywordflow">while</span> (<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a3669d9c05470178c27d910994a1bb512">UART_FSR_TX_FULL_F_Msk</a>);</div>
<div class="line"><a id="l00547" name="l00547"></a><span class="lineno">  547</span> </div>
<div class="line"><a id="l00548" name="l00548"></a><span class="lineno">  548</span>        <span class="keywordflow">if</span> (*ptr == <span class="charliteral">&#39;\n&#39;</span>)</div>
<div class="line"><a id="l00549" name="l00549"></a><span class="lineno">  549</span>        {</div>
<div class="line"><a id="l00550" name="l00550"></a><span class="lineno">  550</span>            <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;THR = <span class="charliteral">&#39;\r&#39;</span>;</div>
<div class="line"><a id="l00551" name="l00551"></a><span class="lineno">  551</span> </div>
<div class="line"><a id="l00552" name="l00552"></a><span class="lineno">  552</span>            <span class="keywordflow">while</span> (<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#a3669d9c05470178c27d910994a1bb512">UART_FSR_TX_FULL_F_Msk</a>);</div>
<div class="line"><a id="l00553" name="l00553"></a><span class="lineno">  553</span>        }</div>
<div class="line"><a id="l00554" name="l00554"></a><span class="lineno">  554</span> </div>
<div class="line"><a id="l00555" name="l00555"></a><span class="lineno">  555</span>        <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;THR = *ptr++;</div>
<div class="line"><a id="l00556" name="l00556"></a><span class="lineno">  556</span>    }</div>
<div class="line"><a id="l00557" name="l00557"></a><span class="lineno">  557</span> </div>
<div class="line"><a id="l00558" name="l00558"></a><span class="lineno">  558</span>    <span class="keywordflow">return</span> len;</div>
<div class="line"><a id="l00559" name="l00559"></a><span class="lineno">  559</span>}</div>
<div class="line"><a id="l00560" name="l00560"></a><span class="lineno">  560</span> </div>
<div class="line"><a id="l00561" name="l00561"></a><span class="lineno">  561</span> </div>
<div class="line"><a id="l00562" name="l00562"></a><span class="lineno">  562</span><span class="keywordtype">int</span> _read(<span class="keywordtype">int</span> fd, <span class="keywordtype">char</span> *ptr, <span class="keywordtype">int</span> len)</div>
<div class="line"><a id="l00563" name="l00563"></a><span class="lineno">  563</span>{</div>
<div class="line"><a id="l00564" name="l00564"></a><span class="lineno">  564</span>    <span class="keywordflow">while</span> ((<a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;FSR &amp; <a class="code hl_define" href="../../da/d91/_nano1_x2_series_8h.html#aa8c7bcb82bb87f1e1e382bcfeb465677">UART_FSR_RX_EMPTY_F_Msk</a>) != 0);</div>
<div class="line"><a id="l00565" name="l00565"></a><span class="lineno">  565</span> </div>
<div class="line"><a id="l00566" name="l00566"></a><span class="lineno">  566</span>    *ptr = <a class="code hl_define" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>-&gt;RBR;</div>
<div class="line"><a id="l00567" name="l00567"></a><span class="lineno">  567</span>    <span class="keywordflow">return</span> 1;</div>
<div class="line"><a id="l00568" name="l00568"></a><span class="lineno">  568</span>}</div>
<div class="line"><a id="l00569" name="l00569"></a><span class="lineno">  569</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00570" name="l00570"></a><span class="lineno">  570</span> </div>
<div class="line"><a id="l00571" name="l00571"></a><span class="lineno">  571</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00572" name="l00572"></a><span class="lineno">  572</span> </div>
<div class="line"><a id="l00583" name="l00583"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#ab11a990e4f8863a1e7736e3c1d430092">  583</a></span><span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#ab11a990e4f8863a1e7736e3c1d430092">fgetc</a>(FILE *stream)</div>
<div class="line"><a id="l00584" name="l00584"></a><span class="lineno">  584</span>{</div>
<div class="line"><a id="l00585" name="l00585"></a><span class="lineno">  585</span>    <span class="keywordflow">return</span> ((<span class="keywordtype">int</span>)<a class="code hl_function" href="../../d3/d3d/retarget_8c.html#ad71fc5c80d56f83994f96dc83d0bbabe">GetChar</a>());</div>
<div class="line"><a id="l00586" name="l00586"></a><span class="lineno">  586</span>}</div>
<div class="line"><a id="l00587" name="l00587"></a><span class="lineno">  587</span> </div>
<div class="line"><a id="l00588" name="l00588"></a><span class="lineno">  588</span> </div>
<div class="line"><a id="l00603" name="l00603"></a><span class="lineno"><a class="line" href="../../d3/d3d/retarget_8c.html#a4a98383bb54291c2abede7aa28acf597">  603</a></span><span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a4a98383bb54291c2abede7aa28acf597">ferror</a>(FILE *stream)</div>
<div class="line"><a id="l00604" name="l00604"></a><span class="lineno">  604</span>{</div>
<div class="line"><a id="l00605" name="l00605"></a><span class="lineno">  605</span>    <span class="keywordflow">return</span> EOF;</div>
<div class="line"><a id="l00606" name="l00606"></a><span class="lineno">  606</span>}</div>
<div class="line"><a id="l00607" name="l00607"></a><span class="lineno">  607</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00608" name="l00608"></a><span class="lineno">  608</span> </div>
<div class="line"><a id="l00609" name="l00609"></a><span class="lineno">  609</span> </div>
<div class="line"><a id="l00610" name="l00610"></a><span class="lineno">  610</span><span class="preprocessor">#ifdef DEBUG_ENABLE_SEMIHOST</span></div>
<div class="line"><a id="l00611" name="l00611"></a><span class="lineno">  611</span><span class="preprocessor">#ifdef __ICCARM__</span></div>
<div class="line"><a id="l00612" name="l00612"></a><span class="lineno">  612</span><span class="keywordtype">void</span> __exit(<span class="keywordtype">int</span> return_code)</div>
<div class="line"><a id="l00613" name="l00613"></a><span class="lineno">  613</span>{</div>
<div class="line"><a id="l00614" name="l00614"></a><span class="lineno">  614</span>    <span class="comment">/* Check if link with ICE */</span></div>
<div class="line"><a id="l00615" name="l00615"></a><span class="lineno">  615</span>    <span class="keywordflow">if</span> (SH_DoCommand(0x18, 0x20026, <a class="code hl_define" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga070d2ce7b6bb7e5c05602aa8c308d0c4">NULL</a>) == 0)</div>
<div class="line"><a id="l00616" name="l00616"></a><span class="lineno">  616</span>    {</div>
<div class="line"><a id="l00617" name="l00617"></a><span class="lineno">  617</span>        <span class="comment">/* Make sure all message is print out */</span></div>
<div class="line"><a id="l00618" name="l00618"></a><span class="lineno">  618</span>        <span class="keywordflow">while</span> (<a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a5a6e4a05dd526dca0c0432dc738a7a02">IsDebugFifoEmpty</a>() == 0);</div>
<div class="line"><a id="l00619" name="l00619"></a><span class="lineno">  619</span>    }</div>
<div class="line"><a id="l00620" name="l00620"></a><span class="lineno">  620</span> </div>
<div class="line"><a id="l00621" name="l00621"></a><span class="lineno">  621</span>label:</div>
<div class="line"><a id="l00622" name="l00622"></a><span class="lineno">  622</span>    <span class="keywordflow">goto</span> label;  <span class="comment">/* Endless loop */</span></div>
<div class="line"><a id="l00623" name="l00623"></a><span class="lineno">  623</span>}</div>
<div class="line"><a id="l00624" name="l00624"></a><span class="lineno">  624</span> </div>
<div class="line"><a id="l00625" name="l00625"></a><span class="lineno">  625</span><span class="preprocessor">#else</span></div>
<div class="line"><a id="l00626" name="l00626"></a><span class="lineno">  626</span> </div>
<div class="line"><a id="l00627" name="l00627"></a><span class="lineno">  627</span><span class="keywordtype">void</span> _sys_exit(<span class="keywordtype">int</span> return_code)</div>
<div class="line"><a id="l00628" name="l00628"></a><span class="lineno">  628</span>{</div>
<div class="line"><a id="l00629" name="l00629"></a><span class="lineno">  629</span>    <span class="comment">/* Check if link with ICE */</span></div>
<div class="line"><a id="l00630" name="l00630"></a><span class="lineno">  630</span>    <span class="keywordflow">if</span> (SH_DoCommand(0x18, 0x20026, <a class="code hl_define" href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga070d2ce7b6bb7e5c05602aa8c308d0c4">NULL</a>) == 0)</div>
<div class="line"><a id="l00631" name="l00631"></a><span class="lineno">  631</span>    {</div>
<div class="line"><a id="l00632" name="l00632"></a><span class="lineno">  632</span>        <span class="comment">/* Make sure all message is print out */</span></div>
<div class="line"><a id="l00633" name="l00633"></a><span class="lineno">  633</span>        <span class="keywordflow">while</span> (<a class="code hl_function" href="../../d3/d3d/retarget_8c.html#a5a6e4a05dd526dca0c0432dc738a7a02">IsDebugFifoEmpty</a>() == 0);</div>
<div class="line"><a id="l00634" name="l00634"></a><span class="lineno">  634</span>    }</div>
<div class="line"><a id="l00635" name="l00635"></a><span class="lineno">  635</span> </div>
<div class="line"><a id="l00636" name="l00636"></a><span class="lineno">  636</span>label:</div>
<div class="line"><a id="l00637" name="l00637"></a><span class="lineno">  637</span>    <span class="keywordflow">goto</span> label;  <span class="comment">/* Endless loop */</span></div>
<div class="line"><a id="l00638" name="l00638"></a><span class="lineno">  638</span>}</div>
<div class="line"><a id="l00639" name="l00639"></a><span class="lineno">  639</span> </div>
<div class="line"><a id="l00640" name="l00640"></a><span class="lineno">  640</span><span class="preprocessor">#endif</span></div>
<div class="line"><a id="l00641" name="l00641"></a><span class="lineno">  641</span><span class="preprocessor">#endif</span></div>
<div class="ttc" id="a_nano1_x2_series_8h_html"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html">Nano1X2Series.h</a></div><div class="ttdoc">Nano102/112 peripheral access layer header file. This file contains all the peripheral register's def...</div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_a3669d9c05470178c27d910994a1bb512"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#a3669d9c05470178c27d910994a1bb512">UART_FSR_TX_FULL_F_Msk</a></div><div class="ttdeci">#define UART_FSR_TX_FULL_F_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10209">Nano1X2Series.h:10209</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_aa8c7bcb82bb87f1e1e382bcfeb465677"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#aa8c7bcb82bb87f1e1e382bcfeb465677">UART_FSR_RX_EMPTY_F_Msk</a></div><div class="ttdeci">#define UART_FSR_RX_EMPTY_F_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10188">Nano1X2Series.h:10188</a></div></div>
<div class="ttc" id="a_nano1_x2_series_8h_html_afefb95cc21b2b73616b108c184730257"><div class="ttname"><a href="../../da/d91/_nano1_x2_series_8h.html#afefb95cc21b2b73616b108c184730257">UART_FSR_TE_F_Msk</a></div><div class="ttdeci">#define UART_FSR_TE_F_Msk</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10212">Nano1X2Series.h:10212</a></div></div>
<div class="ttc" id="agroup___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gaf94add8ada1485e9cedbf027acebfa00"><div class="ttname"><a href="../../d3/d0c/group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf94add8ada1485e9cedbf027acebfa00">__attribute__</a></div><div class="ttdeci">__attribute__((weak))</div><div class="ttdoc">A callback called by library while smartcard request for a time extension.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00187">retarget.c:187</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2___i_o___r_o_u_t_i_n_e_html_ga5421a39a0460ea2269ae45d3e9909991"><div class="ttname"><a href="../../d6/d70/group___n_a_n_o1_x2___i_o___r_o_u_t_i_n_e.html#ga5421a39a0460ea2269ae45d3e9909991">M16</a></div><div class="ttdeci">#define M16(addr)</div><div class="ttdoc">Get a 16-bit unsigned value from specified address.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10693">Nano1X2Series.h:10693</a></div></div>
<div class="ttc" id="agroup___n_a_n_o1_x2__legacy___constants_html_ga070d2ce7b6bb7e5c05602aa8c308d0c4"><div class="ttname"><a href="../../d4/d75/group___n_a_n_o1_x2__legacy___constants.html#ga070d2ce7b6bb7e5c05602aa8c308d0c4">NULL</a></div><div class="ttdeci">#define NULL</div><div class="ttdoc">NULL pointer.</div><div class="ttdef"><b>Definition:</b> <a href="../../da/d91/_nano1_x2_series_8h_source.html#l10812">Nano1X2Series.h:10812</a></div></div>
<div class="ttc" id="aretarget_8c_html_a099c43ad08420cc1950b5958939dbb0b"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a099c43ad08420cc1950b5958939dbb0b">DumpStack</a></div><div class="ttdeci">static void DumpStack(uint32_t stack[])</div><div class="ttdoc">Helper function to dump register while hard fault occurred.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00103">retarget.c:103</a></div></div>
<div class="ttc" id="aretarget_8c_html_a0a9d8f093940fa3017cf1d9337ce5f25"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a0a9d8f093940fa3017cf1d9337ce5f25">SH_Return</a></div><div class="ttdeci">int32_t SH_Return(int32_t n32In_R0, int32_t n32In_R1, int32_t *pn32Out_R0)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00175">retarget.c:175</a></div></div>
<div class="ttc" id="aretarget_8c_html_a1647e9479b4be5731d79c81af76826c5"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a1647e9479b4be5731d79c81af76826c5">_ttywrch</a></div><div class="ttdeci">void _ttywrch(int ch)</div><div class="ttdoc">C library retargetting.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00503">retarget.c:503</a></div></div>
<div class="ttc" id="aretarget_8c_html_a32d2b4f69d4059618d9c49a894523cfa"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a32d2b4f69d4059618d9c49a894523cfa">fputc</a></div><div class="ttdeci">int fputc(int ch, FILE *stream)</div><div class="ttdoc">Write character to stream.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00527">retarget.c:527</a></div></div>
<div class="ttc" id="aretarget_8c_html_a49be7df965b3acf68e2c5c82d6869ab6"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a49be7df965b3acf68e2c5c82d6869ab6">SendChar</a></div><div class="ttdeci">void SendChar(int ch)</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00352">retarget.c:352</a></div></div>
<div class="ttc" id="aretarget_8c_html_a4a98383bb54291c2abede7aa28acf597"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a4a98383bb54291c2abede7aa28acf597">ferror</a></div><div class="ttdeci">int ferror(FILE *stream)</div><div class="ttdoc">Check error indicator.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00603">retarget.c:603</a></div></div>
<div class="ttc" id="aretarget_8c_html_a5a6e4a05dd526dca0c0432dc738a7a02"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a5a6e4a05dd526dca0c0432dc738a7a02">IsDebugFifoEmpty</a></div><div class="ttdeci">int IsDebugFifoEmpty(void)</div><div class="ttdoc">Check if debug message finished.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00488">retarget.c:488</a></div></div>
<div class="ttc" id="aretarget_8c_html_a6810d0fa478aa8204d73d9fc5d026c64"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a6810d0fa478aa8204d73d9fc5d026c64">SendChar_ToUART</a></div><div class="ttdeci">void SendChar_ToUART(int ch)</div><div class="ttdoc">Routine to send a char.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00261">retarget.c:261</a></div></div>
<div class="ttc" id="aretarget_8c_html_a6821bafc3c88dfb2e433a095df9940c6"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a6821bafc3c88dfb2e433a095df9940c6">BUF_SIZE</a></div><div class="ttdeci">#define BUF_SIZE</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00030">retarget.c:30</a></div></div>
<div class="ttc" id="aretarget_8c_html_a97e9b1fe8d4c010474637a654aad6566"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#a97e9b1fe8d4c010474637a654aad6566">kbhit</a></div><div class="ttdeci">int kbhit(void)</div><div class="ttdoc">Check any char input from UART.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00472">retarget.c:472</a></div></div>
<div class="ttc" id="aretarget_8c_html_ab11a990e4f8863a1e7736e3c1d430092"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#ab11a990e4f8863a1e7736e3c1d430092">fgetc</a></div><div class="ttdeci">int fgetc(FILE *stream)</div><div class="ttdoc">Get character from UART debug port or semihosting input.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00583">retarget.c:583</a></div></div>
<div class="ttc" id="aretarget_8c_html_abb2a819d3c88269eba04ea62d759bef5"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#abb2a819d3c88269eba04ea62d759bef5">__stdin</a></div><div class="ttdeci">FILE __stdin</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00058">retarget.c:58</a></div></div>
<div class="ttc" id="aretarget_8c_html_ac1f65ebf7d6f28fb49530ee0095306cb"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#ac1f65ebf7d6f28fb49530ee0095306cb">__stdout</a></div><div class="ttdeci">FILE __stdout</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00057">retarget.c:57</a></div></div>
<div class="ttc" id="aretarget_8c_html_ac607bf387b29162be6a9b77fc7999539"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#ac607bf387b29162be6a9b77fc7999539">__WEAK</a></div><div class="ttdeci">#define __WEAK</div><div class="ttdoc">Routine to send a char.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00350">retarget.c:350</a></div></div>
<div class="ttc" id="aretarget_8c_html_ad71fc5c80d56f83994f96dc83d0bbabe"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#ad71fc5c80d56f83994f96dc83d0bbabe">GetChar</a></div><div class="ttdeci">char GetChar(void)</div><div class="ttdoc">Routine to get a char.</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00399">retarget.c:399</a></div></div>
<div class="ttc" id="aretarget_8c_html_ad7725bd9f76ca4bbdfdeb470ac223138"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a></div><div class="ttdeci">#define DEBUG_PORT</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00028">retarget.c:28</a></div></div>
<div class="ttc" id="aretarget_8c_html_adc29c2ff13d900c2f185ee95427fb06ca0d008574886a382d46ba2616c506af41"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca0d008574886a382d46ba2616c506af41">pc</a></div><div class="ttdeci">@ pc</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00094">retarget.c:94</a></div></div>
<div class="ttc" id="aretarget_8c_html_adc29c2ff13d900c2f185ee95427fb06ca20eb91018c3024df2ae3582f6e8e662c"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca20eb91018c3024df2ae3582f6e8e662c">r0</a></div><div class="ttdeci">@ r0</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00094">retarget.c:94</a></div></div>
<div class="ttc" id="aretarget_8c_html_adc29c2ff13d900c2f185ee95427fb06ca22827a377de213db078757f368a86b05"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca22827a377de213db078757f368a86b05">r2</a></div><div class="ttdeci">@ r2</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00094">retarget.c:94</a></div></div>
<div class="ttc" id="aretarget_8c_html_adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a></div><div class="ttdeci">@ lr</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00094">retarget.c:94</a></div></div>
<div class="ttc" id="aretarget_8c_html_adc29c2ff13d900c2f185ee95427fb06ca5d5f095a80fd85c2eb082cf401ea61bd"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca5d5f095a80fd85c2eb082cf401ea61bd">r3</a></div><div class="ttdeci">@ r3</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00094">retarget.c:94</a></div></div>
<div class="ttc" id="aretarget_8c_html_adc29c2ff13d900c2f185ee95427fb06ca9e5d4ad994db934322c89e4dbef3f7ce"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca9e5d4ad994db934322c89e4dbef3f7ce">r1</a></div><div class="ttdeci">@ r1</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00094">retarget.c:94</a></div></div>
<div class="ttc" id="aretarget_8c_html_adc29c2ff13d900c2f185ee95427fb06cab85e19a5be81ee4c3b2e1a7f1081b01a"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06cab85e19a5be81ee4c3b2e1a7f1081b01a">r12</a></div><div class="ttdeci">@ r12</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00094">retarget.c:94</a></div></div>
<div class="ttc" id="aretarget_8c_html_adc29c2ff13d900c2f185ee95427fb06cafd586543cfec6b0f210fe63e60296dcd"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06cafd586543cfec6b0f210fe63e60296dcd">psr</a></div><div class="ttdeci">@ psr</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00094">retarget.c:94</a></div></div>
<div class="ttc" id="aretarget_8c_html_af1f65f8ccc2d14501465115086e9c761"><div class="ttname"><a href="../../d3/d3d/retarget_8c.html#af1f65f8ccc2d14501465115086e9c761">g_ICE_Conneced</a></div><div class="ttdeci">static volatile int32_t g_ICE_Conneced</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00093">retarget.c:93</a></div></div>
<div class="ttc" id="astruct_____f_i_l_e_html"><div class="ttname"><a href="../../da/d3e/struct_____f_i_l_e.html">__FILE</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00038">retarget.c:39</a></div></div>
<div class="ttc" id="astruct_____f_i_l_e_html_ac65d6afc3b2c74e74d56195829a1626f"><div class="ttname"><a href="../../da/d3e/struct_____f_i_l_e.html#ac65d6afc3b2c74e74d56195829a1626f">__FILE::handle</a></div><div class="ttdeci">int handle</div><div class="ttdef"><b>Definition:</b> <a href="../../d3/d3d/retarget_8c_source.html#l00040">retarget.c:40</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 18 2024 12:20:31 for NANO102/112 BSP by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
